import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import React, { Component } from 'react';
import { connect } from "react-redux";
import CartItem from "./CartItem";
import CartSummaryAlerts from '../Alerts/CartSummaryAlerts';
import CartSummaryEmptyAlert from "../Alerts/CartSummaryEmptyAlert";
import { getCartTotal } from "../../../helper/cartSummary";
import CartSummary from "../../../GPCart";

var CartSummaryContainer =
/*#__PURE__*/
function (_Component) {
  _inherits(CartSummaryContainer, _Component);

  function CartSummaryContainer() {
    _classCallCheck(this, CartSummaryContainer);

    return _possibleConstructorReturn(this, _getPrototypeOf(CartSummaryContainer).apply(this, arguments));
  }

  _createClass(CartSummaryContainer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.createCart(this.props.userToken, this.props.env, this.props.orderId);
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      return React.createElement("div", {
        className: "shopping-list"
      }, React.createElement("div", {
        className: "list-wrapper"
      }, this.props.cart && this.props.alerts === true && React.createElement(CartSummaryAlerts, null), React.createElement("h3", {
        className: "product-group"
      }, "Products"), this.props.cart && this.props.cart && this.props.cart.subTotal === 0 && React.createElement(CartSummaryEmptyAlert, null), this.props.cart && this.props.cart && this.props.cart.items.map(function (book, index) {
        return React.createElement(CartItem, {
          book: book,
          onRemove: _this.props.removeCartItem,
          key: index,
          cart: _this.props.cart,
          orderId: _this.props.orderId,
          env: _this.props.env,
          userToken: _this.props.userToken
        });
      })));
    }
  }]);

  return CartSummaryContainer;
}(Component);

function mapStateToProps(state) {
  return {
    cart: state.cartActions.cart,
    alerts: state.cartActions.alerts,
    billingContact: state.cartActions.billingContact
  };
}

;

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    createCart: function createCart(userToken, env, orderId) {
      dispatch({
        type: 'CREAT_N_FETCH_CART_DATA',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId
        }
      });
    },
    removeCartItem: function removeCartItem(event, cart, orderId, env, userToken) {
      var productId = event.target.attributes["data-item-id"].value;

      var tempCartItems = _objectSpread({}, cart);

      tempCartItems.items = cart.items.filter(function (item) {
        return item.productId !== productId;
      });
      tempCartItems.subTotal = getCartTotal(tempCartItems.items);
      dispatch({
        type: 'REMOVE_ITEM_FROM_CART_DATA',
        data: tempCartItems,
        alerts: true
      });
      dispatch({
        type: 'UPDATE_CART_DATA',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: tempCartItems
        }
      });
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(CartSummaryContainer);